<?php
/*
	ApacheStats 0.6?
		This is based off of the apachestats of Rolf Poser. The most recent thread is here. http://forums.cacti.net/viewtopic.php?t=9861

		***This will only work with PHP 5.x*** Sorry. I'm working on a fix as my main cacti box runs PHP 4.4

	ss_apache_stats.php

	This is the script server verstion of the apachestats script

	Usage:

	From the command line:
		ss_apache_stats.php <hostname> 
	
	As a script server object:
		ss_apache_stats.php ss_apache_stats <hostname>

	Where <hostname> is the hostname (imagine that) of the webserver you are graphing against 

$no_http_headers = true;

/* display ALL errors */
error_reporting(0);

if (!isset($called_by_script_server)) {
        include_once(dirname(__FILE__) . "/../include/config.php");

        array_shift($_SERVER["argv"]);

        print call_user_func_array("ss_apache_stats", $_SERVER["argv"]);
}

function ss_apache_stats($host="localhost")
{
	$variables = array('apache_total_hits', 'apache_total_kbytes', 'apache_busy_workers', 'apache_idle_workers', 'apache_cpuload');
	$threads = array('_W' => 0,'S' => 0,'R'=>0,'W'=>0,'K'=>0,'D'=>0,'C'=>0,'L'=>0,'G'=>0,'I'=>0,'_O'=>0);
/*	***Types of Threads***
	_W --- waiting
	S  --- starting up
	R  --- reading request
	W  --- sending reply
	K  --- keepalive
	D  --- DNS lookup
	C  --- closing connection
	L  --- logging
	G  --- graceful finishing
	I  --- idle cleanup
	_O --- open slot
*/
	$ch = curl_init();
	$url = "http://".$host."/server-status?auto";
	//Set the URL we want to grab
	curl_setopt($ch, CURLOPT_URL, $url);
	//Make sure cURL doesn't output anything
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	//Let cURL do its thing
	$result = curl_exec($ch);
	// close cURL connection
	curl_close($ch);
	$array_result = array();
	$array_result =  explode("\n",$result);
	$i = 0;
	$output = "";
	$line = array();
	foreach ( $array_result as $newline)
	{
		$line = explode(":", $newline);
	
		switch ($line[0])
		{
			case "Total Accesses":
				$output .= $variables[0].":".trim($line[1])." ";
			break;
			case "Total kBytes":
				$output .= $variables[1].":".trim($line[1])." ";
			break;
			case "BusyWorkers":
				$output .= $variables[2].":".trim($line[1])." ";
			break;
			case "IdleWorkers":
				$output .= $variables[3].":".trim($line[1])." ";
			break;
			case "CPULoad":
				$output .= $variables[4].":".trim($line[1])." ";
			break;
			case "Scoreboard":
				//PHP4 fix
				if(function_exists("str_split"))
                {
                	$temp = str_split(trim($line[1]));
                }
				//Since we can't use str_split in PHP5 we must improvise
                else {
                	$temp = preg_split ('//', trim($line[1]), -1, PREG_SPLIT_NO_EMPTY);
                }

				foreach ($temp as $char)
				{
					if($char == '_')
						$threads['_W']++;
					else if($char == '.')
						$threads['_O']++;
					else
						$threads[$char]++;
				}//end foreach
			break;
		}//end switch
	}//end foreach

	foreach ($threads as $type => $num_threads)
	{
		$output.= "thread".$type.":".$num_threads." ";
	}//end foreach

	return trim(str_replace("\r","", str_replace("\n", "", $output)));

}//end ss_apache_stats function

?>
